#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "hashmap.h"

void print_capital_city(struct hashmap_t *hashmap,
			K key) {
  V value;  
  if(hashmap_get(hashmap, key, value))
    printf("Capital of %s is %s\n", key, value);
  else
    printf("Cannot find the Capital of %s\n", key);
}

int main() {
  struct hashmap_t hashmap;

  printf("# Initialize hashmap\n");
  hashmap_init(&hashmap);

  printf("# Add 50 elements in the hashmap\n");
  hashmap_put(&hashmap, "Chine", "Pekin");
  hashmap_put(&hashmap, "Japon", "Tokyo");
  hashmap_put(&hashmap, "Republique democratique du Congo", "Kinshasa");
  hashmap_put(&hashmap, "Russie", "Moscou");
  hashmap_put(&hashmap, "Coree du Sud", "Seoul");
  hashmap_put(&hashmap, "Indonesie", "Jakarta");
  hashmap_put(&hashmap, "Bangladesh", "Dacca");
  hashmap_put(&hashmap, "Mexique", "Mexico");
  hashmap_put(&hashmap, "Royaume-Uni", "Londres");
  hashmap_put(&hashmap, "Perou", "Lima");
  hashmap_put(&hashmap, "Thaïlande", "Bangkok");
  hashmap_put(&hashmap, "Iran", "Teheran");
  hashmap_put(&hashmap, "Colombie", "Bogota");
  hashmap_put(&hashmap, "Egypte	Le", "Caire");
  hashmap_put(&hashmap, "Iraq", "Bagdad");
  hashmap_put(&hashmap, "Singapour", "Singapour");
  hashmap_put(&hashmap, "Turquie", "Ankara");
  hashmap_put(&hashmap, "Chili", "Santiago");
  hashmap_put(&hashmap, "Arabie saoudite", "Riyad");
  hashmap_put(&hashmap, "Algerie", "Alger");
  hashmap_put(&hashmap, "Allemagne", "Berlin");
  hashmap_put(&hashmap, "Syrie", "Damas");
  hashmap_put(&hashmap, "Viêt Nam", "Hanoï");
  hashmap_put(&hashmap, "Espagne", "Madrid");
  hashmap_put(&hashmap, "Coree du Nord", "Pyongyang");
  hashmap_put(&hashmap, "Afghanistan", "Kaboul");
  hashmap_put(&hashmap, "Kenya", "Nairobi");
  hashmap_put(&hashmap, "Ethiopie", "Addis-Abeba");
  hashmap_put(&hashmap, "Argentine", "Buenos Aires");
  hashmap_put(&hashmap, "Italie", "Rome");
  hashmap_put(&hashmap, "Ukraine", "Kiev");
  hashmap_put(&hashmap, "Taïwan", "Taipei");
  hashmap_put(&hashmap, "Bresil", "Brasília");
  hashmap_put(&hashmap, "Jordanie", "Amman");
  hashmap_put(&hashmap, "Angola", "Luanda");
  hashmap_put(&hashmap, "Afrique du Sud", "Pretoria");
  hashmap_put(&hashmap, "France", "Paris");
  hashmap_put(&hashmap, "Ouzbekistan", "Tachkent");
  hashmap_put(&hashmap, "Azerbaïdjan", "Bakou");
  hashmap_put(&hashmap, "Suède", "Stockholm");
  hashmap_put(&hashmap, "Cuba", "La Havane");
  hashmap_put(&hashmap, "Cambodge", "Phnom Penh");
  hashmap_put(&hashmap, "Roumanie", "Bucarest");
  hashmap_put(&hashmap, "Venezuela", "Caracas");
  hashmap_put(&hashmap, "Maroc", "Rabat");
  hashmap_put(&hashmap, "Autriche", "Vienne");
  hashmap_put(&hashmap, "Soudan", "Khartoum");
  hashmap_put(&hashmap, "Hongrie", "Budapest");
  hashmap_put(&hashmap, "Pologne", "Varsovie");
  hashmap_put(&hashmap, "Bielorussie", "Minsk");
  
  printf("\n# Testing hashmap_size\n");
  printf ("Hashmap size (50) = %d\n", hashmap_size(&hashmap)); 
  assert(hashmap_size(&hashmap) ==  50);

  printf("\n# Testing hashmap_remove\n");
  hashmap_remove(&hashmap, "Bielorussie", "Minsk");
  assert(hashmap_get(&hashmap, "Bielorussie", "Minsk") == 0);

  printf("\n# Testing hashmap_replace\n");
  hashmap_replace(&hashmap, "France", "ABienEteModifiee");
  print_capital_city(&hashmap, "France");
  
  printf("\n# Finalize the hashmap\n");
  hashmap_finalize(&hashmap);

  return EXIT_SUCCESS;
}
